package cnv.hf.widgets;

import hmi.mapctrls.HPMapAPI;
import hmi.packages.HPAppEnv;
import hmi.packages.HPGLRenderer;
import hmi.packages.HPSysEnv;
import hmi.packages.HPWidgetEvent;
import hmi.packages.HPWidgetEvent.HPWidgetEventArgument;
import hmi.packages.HPWidgetEvent.HPWidgetEventType;
import hmi.packages.HPWidgetEvent.HPWidgetKeyArgument;
import hmi.packages.HPWidgetEvent.HPWidgetKeyEvent;
import hmi.packages.HPWindowManager;

import java.util.ArrayList;
import java.util.Vector;

import android.annotation.SuppressLint;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.Canvas;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.Fragment;
import android.util.DisplayMetrics;
import android.view.Display;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.widget.AbsoluteLayout;
import android.widget.AbsoluteLayout.LayoutParams;
import android.widget.AdapterView;
import cnv.hf.widgets.HFModeActivity.HFOnMessageInterface;
import cnv.hf.widgets.HFModesManager.HFOrientation;
import cnv.hf.widgets.HFModesManager.HFPendingTransition;
import cnv.hf.widgets.HFWidgetStorage.HFLayerStorage;
import cnv.hf.widgets.HFWidgetStorage.HFModeStorage;
import cnv.hf.widgets.HFWidgetsManager.HFWidgetType;

@SuppressWarnings("deprecation")
public abstract class HFModeFragment extends Fragment implements HFModeWidget{
	
	//key
	public final static String KEY_REQUEST_CODE = "FRAGMENT_REQUEST_CODE";
	private boolean       reEnterFlag = false;
	private HFMapActivity mContext = null;
	private AbsoluteLayout mScrollView = null;
	private Vector<HFLayerWidget> mLayers = null;
	private ArrayList<HFRadioButtonWidget> mRadioButtons = null;
	private HPWidgetEventArgument mEventArgs = null;  
	private HFOnMessageInterface mOnMessageListener = null;
	private HFFragmentHandler mFragmentHandler = null;
	private HFModeStorage mModeData = null;
	//X᷽
	private float mXScaleFactor = 1.0f;
	//Y᷽
	private float mYScaleFactor = 1.0f; 
	//ĬϴģʽĶΪңرģʽʱҵ
	private int mPendingTransition = HFPendingTransition.ePendingTransition_LeftRight;
	//ǰģʽĺ汾
	private int mOrientation = 0;
	//ǰSysEnv
	public HPSysEnv sysEnv = null;
	//󷵻ؽ
	private HFFragmentResult mResult = null;
	//intent
	private Intent mIntent = null;
	//ǰģʽǷMapViewؼ
	private boolean mIsContainMapView = false;
	//ǰģʽǷŻͼ㼰ؼķʽ
	private boolean mIsOptimized = false;
	//ģʽ
	private HFModeLoader mModeLoader = null;
	//ЧձϢ
	private final int HF_CLEAR_BACKGROUND_MESSAGE_ID = 2014112011;
	//ģʽʱ
	private int  mPendingTransitionTime = 500;
	//Ƿǲ˵ģʽ
	private boolean mIsMenuMode = false;
	/** ǷͨaddFragmentfragment򵱸fragment˳ʱonRenter */
	private boolean mIsStartedByAdd = false;
	
	//added by LiangYJ 20150729
	private HFAnalyticsStorage mAnalyticsStorage;
	//end
	
	//ʶ
	private String mSingleTag = "";
	
	//лҪ¼ģʽͼ
	public boolean isChangeOrationNeedRenewModeData = false;
	
	/** Ƿӵ˶ջ*/
	public boolean isAddToTask = true;
	/** ǷҪò*/
	private boolean resetLayout = false;
	/**
	 * Ƿ²
	 */
	protected boolean shouldResetLayout = true;
	protected boolean checkLayoutOnResume = false;
	
//	private IKeyBoardListener mKeyBoardListener;
//	/** Ƿ񵯳 */
//	private boolean mIsKeyBoardDisplay = false;
	
//	@Override
//	public void onAttach(Activity activity){
//		super.onAttach(activity);
//	}
//	
//	@Override
//	public void onDetach(){
//		super.onDetach();
//	}
	
    @SuppressLint("NewApi")
	@Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);

		HFModesManager.isCreatingFragment = false;
		if (Build.VERSION.SDK_INT >= 24
				&& (Build.MANUFACTURER.equalsIgnoreCase("OPPO"))) {

			if(HFModesManager.shouldResetScreenOnFrameCreate || !HFModesManager.resetLayoutOnCurrentMode){
				//Ǻǵ༭
				if (getContext().getResources().getConfiguration().orientation == Configuration.ORIENTATION_LANDSCAPE
						&& !HFModesManager.resetLayoutOnCurrentMode) {
					HFModesManager.resetLayoutOnCurrentMode = true;
					return;
				}
				checkLayoutOnResume = true;
				HPWindowManager windowMan = new HPWindowManager(getContext());
				Display display = windowMan.getDefaultDisplay();

				DisplayMetrics realOutMetrics = new DisplayMetrics();
				display.getRealMetrics(realOutMetrics);
				int height = 0;
				int width = 0;
				height = display.getHeight();
				width = display.getWidth();
				// ǻȡĿ;Ǻǻȡĸ߿
				if (getContext().getResources().getConfiguration().orientation == Configuration.ORIENTATION_PORTRAIT) {
					HFModesManager.setScreenPixels(width, height);
				} else {
					HFModesManager.setScreenPixels(height, width);
				}
				HFModesManager.shouldResetScreenOnFrameCreate = false;
				HFModesManager.resetLayoutOnCurrentMode = true;
			}
		}
    }
    
    private int getMenuWidth(){
    	int width = 0;
    	for(int i = 0; i < mScrollView.getChildCount();i++){
    		if(mScrollView.getChildAt(i) instanceof HFLayerWidget){
    			HFLayerWidget layer = (HFLayerWidget)mScrollView.getChildAt(i);
    			if(layer.getBound().getWidth() > width)
    				width = layer.getBound().getWidth();
    		}
    	}
    	return width;
    }
    
    protected void init(Context context) {
    	if(mScrollView == null) {	
	    	mContext = (HFMapActivity) context;
	    	//ջ,˵Ӧջ
	    	if(getId() != HFModeActivity.HF_MENU_CONTENT_ID)
	    	  mContext.pushFragment(this);
	    	sysEnv = mContext.getSysEnv();
	    	//ʼ
	    	initRequestArgs();
			//ģʽ桡
			setOrientation(HFModesManager.getOrientation());
			//ģʽ
			setPendingTransition(HFModesManager.getTempTransition());
			mModeData = new HFModeStorage();
			//scrollView
			mScrollView = new AbsoluteLayout(mContext);
	        //ͼ
	        mLayers = new Vector<HFLayerWidget>();
	        //RadioButton
	        mRadioButtons = new ArrayList<HFRadioButtonWidget>();
	        //óʼǰ
	        onBeforeInit();
	        //װͼͼ
	        loadLayerWidgets();
	        //Fragmentڲhandler
	        mFragmentHandler = new HFFragmentHandler();
	        //óʼ
	        onInit(); 
//	        mScrollView.setKeepScreenOn(mIsContainMapView);
	        if(this.getClass() == HFSlideMenu.m_MenuCls){
	           mIsMenuMode = true; 
	           HFSlideMenu.mMenuWidth = getMenuWidth();
	        }
	        
//	        mScrollView.getViewTreeObserver().addOnGlobalLayoutListener(
//	                 new ViewTreeObserver.OnGlobalLayoutListener() {
//	                         @Override
//	                         public void onGlobalLayout() {
//	                        	 Rect r = new Rect();
//                                 mScrollView.getWindowVisibleDisplayFrame(r);
//                                 int screenHeight = getRootView().getHeight();
//                                 int KeyboardHeigth = screenHeight - (r.bottom - r.top);
//                                 mIsKeyBoardDisplay = KeyboardHeigth > HFUnitsUtils.dip2px(100);
//	                        	 if(mKeyBoardListener != null){
//	                                 mKeyBoardListener.onKeyBoardDisplay(mIsKeyBoardDisplay);
//	                        	 }
//	                         }
//	                    });	
    	}
		else {
			ViewParent parent = mScrollView.getParent();
			if(parent != null && parent instanceof ViewGroup) {
				ViewGroup vg = (ViewGroup) parent;
				vg.removeView(mScrollView);
			}
		}
    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Begin);
    	init(this.getActivity());
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Finish);
        return mScrollView;
    }
	
	protected void unbindDrawables(View view) {  
	    if (view.getBackground() != null) { 
	    	Drawable bg = view.getBackground();
	    	if(bg instanceof BitmapDrawable) {
	    		BitmapDrawable bd = (BitmapDrawable) bg;
	    		Bitmap bm = bd.getBitmap();
	    		if( bm != null && !bm.isRecycled()) {
	    			bm.recycle();
	    		}
	    	}
	    	else
	    	if(bg instanceof StateListDrawable) {
	    		StateListDrawable sd = (StateListDrawable) bg;
	    		sd.setCallback(null);
	    	}
	        view.getBackground().setCallback(null);
	    	view.setBackgroundResource(0);
	        view = null;
	    }  
	    if (view instanceof ViewGroup) {  
	        for (int i = 0; i < ((ViewGroup) view).getChildCount(); i++) {  
	            unbindDrawables(((ViewGroup) view).getChildAt(i));  
	        }  
	        if(!(view instanceof AdapterView)) {
	        	((ViewGroup) view).removeAllViews();
	        }
	    }  
	} 	
	@Override
	public void onDestroy() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Begin);
		//رģʽװ
		closeModeLoader(null);
		//ùرպ
		onClose();		
		super.onDestroy();
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Finish);
	}
	 abstract protected String getModeName();	
	/*======================================================
	: ȡģʽװ
	:  
	
	ֵ: ģʽװ
	======================================================*/
	 public HFModeLoader getModeLoader() {	 
		if(mModeLoader == null) {
			mModeLoader = new HFModeLoader();
			String fileName = HFModesManager.getLaoutsPath() + getModeName();
			if(0 == mModeLoader.loadMode(fileName)) {
				return mModeLoader;
			}
			mModeLoader = null;
		}
        return mModeLoader;
	 }
	 
	 /*======================================================
		: ͨļ·ģʽͼ
		:  
		
		ֵ: 
		======================================================*/
	 public int loadMode(String fileName){
		 if(mModeLoader == null) {
			mModeLoader = new HFModeLoader();
			return mModeLoader.loadMode(fileName);
		}
	    return mModeLoader.loadMode(fileName);
	 }
	/*======================================================
	: رģʽװ
	:  
	
	ֵ: 
	======================================================*/
	 public void closeModeLoader(HFModeLoader modeLoader) {
		 if(isOptimized() && modeLoader != null)
			 return ;
		 if(mModeLoader != null) {
			 mModeLoader.close();
		 }
		 mModeLoader = null;
	 }
	/*======================================================
	: ͼݴͼ
	:	modeLoader [in] ģʽ
			layerData  [in] ͼ
	ֵ: ͼ
	======================================================*/
	 public HFLayerWidget createLayerWidgets(HFModeLoader modeLoader, 
			 									HFLayerStorage layerData) {
		 scaleCoords(layerData.getBound(),0);
		 HFWidgetsManager widgetsMan = new HFWidgetsManager(mContext);
		 HFLayerWidget layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, layerData);
		 if(layer != null && !layerData.isOptimized()) {
			 int ret = layer.loadWidgets(mContext, modeLoader);
			 if(ret == 1){
				mIsContainMapView = true;
			 }
//			 //added by LiangYJ 20150817
//			 //ûӿؼͼ㲻ʾһӿؼ
//			 if(layer.getChildCount() == 0){
//				 View view = new View(mContext);
//				 layer.addView(view,new LayoutParams(layer.getBound().getWidth(), layer.getBound().getHeight(),0,0));
//			 }
//			 //end
		 }
		 return layer;
	 }
	 
	 
	 /*======================================================
		: ͼݴͼ
		:	
		        modeLoader [in] ģʽ
				layerId  [in] ͼ
				
		ֵ: ͼ
		======================================================*/
		public HFLayerWidget createLayerWidgets(HFModeLoader modeLoader,int layerId) {
			HFLayerWidget layer = null; 
			if(layerId >  0) {
		        if(modeLoader != null) {
			        int numLayers = modeLoader.getNumOfLayers();
			    	for(int index = 0; index < numLayers; index++) {
			        	HFLayerStorage playerData = new HFLayerStorage();
			    		if(0 == modeLoader.getLayerData(index, playerData)) {
							if(playerData.getId() == layerId) {
								layer = createLayerWidgets(modeLoader, playerData);
								break;
							}
			    		}
			    	}
		        }
			}
	    	if(layer == null) {
	    		//Log.e("CLDLOGTAG", "fragment: " + this.getName());
	    		//Log.e("CLDLOGTAG", String.format("layerId: %s.", layerId));
	    		HFWidgetsManager widgetsMan = new HFWidgetsManager(mContext);
	    		layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, null);
	    	}
			return layer;
		 }	 
	 
	/*======================================================
	: ͼݴͼ
	:	
			layerId  [in] ͼ
			
	ֵ: ͼ
	======================================================*/
	 public HFLayerWidget createLayerWidgets(int layerId) {
//		HFLayerWidget layer = null; 
//		if(layerId >  0) {
//	    	HFModeLoader modeLoader = getModeLoader();
//	        if(modeLoader != null) {
//		        int numLayers = modeLoader.getNumOfLayers();
//		    	for(int index = 0; index < numLayers; index++) {
//		        	HFLayerStorage playerData = new HFLayerStorage();
//		    		if(0 == modeLoader.getLayerData(index, playerData)) {
//						if(playerData.getId() == layerId) {
//							layer = createLayerWidgets(modeLoader, playerData);
//							break;
//						}
//		    		}
//		    	}
//		    	closeModeLoader(modeLoader);
//	        }
//		}
//    	if(layer == null) {
//    		//Log.e("CLDLOGTAG", "fragment: " + this.getName());
//    		//Log.e("CLDLOGTAG", String.format("layerId: %s.", layerId));
//    		HFWidgetsManager widgetsMan = new HFWidgetsManager(mContext);
//    		layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, null);
//    	}
//		return layer;
		return createLayerWidgets(layerId,true);
	 }	 
	 
	 
		/*======================================================
		: ͼݴͼ
		:	
				layerId  [in] ͼ
				
		ֵ: ͼ
		======================================================*/
		 public HFLayerWidget createLayerWidgets(int layerId, boolean closeModeLoader) {
			HFLayerWidget layer = null; 
			if(layerId >  0) {
		    	HFModeLoader modeLoader = getModeLoader();
		        if(modeLoader != null) {
			        int numLayers = modeLoader.getNumOfLayers();
			    	for(int index = 0; index < numLayers; index++) {
			        	HFLayerStorage playerData = new HFLayerStorage();
			    		if(0 == modeLoader.getLayerData(index, playerData)) {
			    			if(playerData.getId() == layerId) {
								layer = createLayerWidgets(modeLoader, playerData);
								break;
							}
			    		}
			    	}
			    	if(closeModeLoader)
			    	    closeModeLoader(modeLoader);
		        }
			}
	    	if(layer == null) {
	    		//Log.e("CLDLOGTAG", "fragment: " + this.getName());
	    		//Log.e("CLDLOGTAG", String.format("layerId: %s.", layerId));
	    		HFWidgetsManager widgetsMan = new HFWidgetsManager(mContext);
	    		layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, null);
	    	}
			return layer;
		 }	 
	/*======================================================
	: װͼ
	:  
	
	ֵ: 
	======================================================*/
	public void loadLayerWidgets() {
		
        HFLayerWidget pLayer = null;
    	HFModeLoader modeLoader = getModeLoader();
        if(modeLoader == null) {
        	return ;
        }	
        boolean isFirst = true;
    	//װģʽ
    	modeLoader.getModeData(mModeData);
    	//
    	calcScaleFactor();
    	int numLayers = modeLoader.getNumOfLayers();
    	for(int i = 0; i < numLayers; i++) {
        	HFLayerStorage playerData = new HFLayerStorage();
    		if(0 == modeLoader.getLayerData(i, playerData)) {
    			if(playerData.getParent() <= 0) {
    				//Żؿؼʽһͼ(ͼ)Ҳȫװ
    				playerData.setIsOptimized((isOptimized() && !isFirst));
    				pLayer = createLayerWidgets(modeLoader, playerData); 
    				addLayerWidget2Display(pLayer);
    				isFirst = false;
    			}			
    		}
    	}
    	closeModeLoader(modeLoader);
	}	
	
	/**
	 * ָͼһView dinghu 2015.6.12
	 * @param view
	 * @param lay
	 * @return void
	 * @author Dinghu
	 * @date 2015612 6:26:19
	 */
	public void addViewBelowLay(View view, HFLayerWidget lay) {

		mScrollView.removeAllViews();
		HFModeLoader modeLoader = getModeLoader();
		if (modeLoader != null) {
			int numLayers = mLayers.size();
			for (int index = 0; index < numLayers; index++) {
				HFLayerWidget layer = mLayers.get(index);

				ViewParent parent = layer.getParent();
				if (parent != null && parent instanceof ViewGroup) {
					ViewGroup vg = (ViewGroup) parent;
					vg.removeView(layer);
				}
				if (!layer.equals(lay)) {
					mScrollView.addView(layer);
				} else {
					mScrollView.addView(view);
					mScrollView.addView(layer);
				}

			}
		}
	}
	/*======================================================
	: ²
	:  
	
	ֵ: 
	======================================================*/
	public void reLayoutWidgets(int src_width,int src_height,int des_width,int des_height){
		//
		double xScale = des_width*1.0/src_width;
    	double yScale = des_height*1.0/src_height;
		for(int i = 0; i < mLayers.size(); i++){
			HFLayerWidget layer = mLayers.get(i);
			HFModesManager.scaleCoords(layer.getBound(),xScale,yScale);
			for(int j = 0; j < layer.getNumOfWidgets();j++){
				HFBaseWidget widget = layer.getWidgetByIndex(j);
				HFModesManager.scaleCoords(widget.getBound(),xScale,yScale);
				layer.reLayoutWidget(j);
			}
			layer.setBound(layer.getBound());
		}
		if(this.getContext() instanceof HFMapActivity){
			HFMapActivity mapActivity = (HFMapActivity)this.getContext();
			View image = mapActivity.findViewById(HFMapActivity.HF_MAPMODE_CONTENT_IMAGEBG_ID);
			int width = des_width;
			int height = des_height;
			if(HFModesManager.isFullScreen() == false){
				height = height - HFModesManager.getStatusBarHeight();
			}
			LayoutParams params = new LayoutParams(width, height,0, 0);
			image.setLayoutParams(params);
			View layer = mapActivity.findViewById(HFMapActivity.HF_MAPMODE_CONTENT_ID);
			layer.setLayoutParams(params);
			HFMapWidget mapWidget = mapActivity.getMapWidget();
			HFWidgetBound bound = new HFWidgetBound();
			bound.setLeft(0);
			bound.setTop(0);
			bound.setHeight(height);
			bound.setWidth(width);
			mapWidget.setBound(bound);
			mapWidget.getObject().setLayoutParams(params);
			layer = mapActivity.findViewById(HFMapActivity.HF_MAPMODE_MAPLAYER_ID);
			layer.setLayoutParams(params);
		}
	}
	/*======================================================
	: ͨӿؼIdȡӿؼ
	:  
			id  [in] ӿؼId
	
	ֵ: ӿؼ
	======================================================*/
	public synchronized HFBaseWidget findWidgetById(int id) {
		
		HFBaseWidget widget = null;
		HFLayerWidget pLayer = null;
		if(mLayers != null){
			synchronized(mLayers)
			{
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null) {
						widget = pLayer.findWidgetById(id);
						if(widget != null) {
							return widget;
						}
					}
				}
			}
		}
		return null;
	}	
	/*======================================================
	: ͨӿؼƻȡӿؼ
	:  
			in_cWidgetName   [in] ӿؼ
	
	ֵ: ӿؼ
	======================================================*/
	public synchronized HFBaseWidget findWidgetByName(String widgetName) {
		
		HFBaseWidget widget = null;
		HFLayerWidget pLayer = null;
		if(mLayers != null){
			synchronized(mLayers)
			{
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null) {
						widget = pLayer.findWidgetByName(widgetName);
						if(widget != null) {
							return widget;
						}
					}
				}
			}
		}
		return null;
	}
	/*======================================================
	: ͨӿؼƻȡӿؼ
	:  
			in_cWidgetName   [in] ӿؼ
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget findWidgetByObject(Object widget) {
		
		HFBaseWidget base = null;
		HFLayerWidget pLayer = null;
		if(mLayers != null){
			synchronized(mLayers)
			{
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null) {
						base = pLayer.findWidgetByObject(widget);
						if(base != null) {
							return base;
						}
					}
				}
			}
		}
		return null;
	}	
	/*======================================================
	: ͨͼȡͼ
	:  
			index   [in] ͼ
	
	ֵ: ͼ
	======================================================*/
	public HFLayerWidget getLayerByIndex(int index) {
		if(mLayers != null){
			synchronized(mLayers)
			{
				if(index >= 0 && index < mLayers.size()) {
					return (HFLayerWidget) mLayers.get(index);
				}
			}
		}
		return null;
	}
	/*======================================================
	: ͨͼIdȡͼ
	:  
			Id   [in] ͼId
	
	ֵ: ͼ
	======================================================*/
	public HFLayerWidget findLayerById(int layerId) {

		HFLayerWidget pLayer = null;
		if(mLayers != null){
			synchronized(mLayers)
			{
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null && pLayer.getWidgetId() == layerId) {
						return pLayer;
					}
				}
			}
		}
		return null;
	}	
	/*======================================================
	: ͨͼƻȡͼ
	:  
			Id   [in] ͼId
	
	ֵ: ͼ
	======================================================*/
	public HFLayerWidget findLayerByName(String layerName) {

		HFLayerWidget pLayer = null;
		if(mLayers != null){
			synchronized(mLayers)
			{
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null && pLayer.getName().equalsIgnoreCase(layerName)) {
						return pLayer;
					}
				}
			}
		}
		return null;
	}	
	/*======================================================
	: һͼлһͼ
	:  
			fromLayer   [in] лͼ 
			toLayer     [in] Ҫлͼ
	
	ֵ: ͼ
	======================================================*/
	public void switchLayerWidget(String fromLayer, String toLayer) {
		
		HFLayerWidget sourcelayer = findLayerByName(fromLayer);
		HFLayerWidget destLayer = findLayerByName(toLayer);
		if(sourcelayer != null) {
			mScrollView.removeView(sourcelayer);
		}
		if(destLayer != null) {
			mScrollView.addView(destLayer);
		}
	}
	/*======================================================
	: һͼģʽϣʾ
	:  
			layerWidget   [in] Ҫӵͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget(HFLayerWidget layerWidget) {
		if(mLayers != null){
			synchronized(mLayers)
			{
				if(layerWidget != null) {
					mLayers.add(layerWidget);
				}
			}
		}
	}
	
	/*======================================================
	: ɾһͼģʽ
	:  
			layerWidget   [in] Ҫɾͼ 

	ֵ: 
	======================================================*/
	public void removeLayerWidget(HFLayerWidget layerWidget){
		if(mLayers != null){
			synchronized(mLayers)
			{
				if(layerWidget != null) {
					mLayers.remove(layerWidget);
				}
			}
		}
	}
	
	/*======================================================
	: һͼ±
	:  
			layerName  [in] ͼ

	ֵ: index
	======================================================*/
	public int getLayerWidgetIndex(String layerName){
		if(mLayers != null){
			synchronized(mLayers)
			{
		        HFLayerWidget pLayer = null;
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null && pLayer.getName().equalsIgnoreCase(layerName)) {
						return index;
					}
				}
			}
		}
		return -1;
	}
	
	/*======================================================
	: һͼʾĵ±
	:  
			layerName  [in] ͼ

	ֵ: index
	======================================================*/
	public int getLayerWidgetIndexFromDisplay(String layerName){
		 HFLayerWidget pLayer = null;
		 for(int index = 0; index < mScrollView.getChildCount(); index++) {
				pLayer = (HFLayerWidget) mScrollView.getChildAt(index);
				if(pLayer != null && pLayer.getName().equalsIgnoreCase(layerName)) {
					return index;
				}
			}
			return -1;
	}
	/*======================================================
	: һͼʾ
	:  
			layerName   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(HFLayerWidget layerWidget) {
		
		if(layerWidget != null) {
			mLayers.add(layerWidget);
			HFWidgetBound bound = layerWidget.getBound();
			if(bound != null) {
				LayoutParams params = new LayoutParams(	bound.getWidth(), bound.getHeight(),
														bound.getLeft(), bound.getTop());
				mScrollView.addView(layerWidget, params);
			}
			else {
				mScrollView.addView(layerWidget);
			}
		}
	}
	
	/*======================================================
	: һͼʾ
	:  
			layerWidget   [in] Ҫʾͼ 
             index        [in] ±
	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(HFLayerWidget layerWidget,int index){
		if(layerWidget != null) {
			mLayers.add(layerWidget);
			HFWidgetBound bound = layerWidget.getBound();
			if(bound != null) {
				LayoutParams params = new LayoutParams(	bound.getWidth(), bound.getHeight(),
														bound.getLeft(), bound.getTop());
				mScrollView.addView(layerWidget,index,params);
			}
			else {
				mScrollView.addView(layerWidget,index);
			}
		}
	}
	
	/*======================================================
	: ģʽ
	:  
			d   [in] ģʽͼ

	ֵ: 
	======================================================*/
	public void setModeBackground(Drawable d){
		if(mScrollView != null)
			mScrollView.setBackgroundDrawable(d);
	}
	
	/*======================================================
	: ȡģʽ
	:  
			d   [in] ģʽͼ

	ֵ: 
	======================================================*/
	public Drawable getModeBackground(){
		if(mScrollView != null)
			return mScrollView.getBackground();
		return null;
	}
	
	/*======================================================
	: ģʽ
	:  

	ֵ: 
	======================================================*/
	public void cleanModeBackground(){
		if(mScrollView != null && mScrollView.getBackground() != null)
			mScrollView.setBackgroundDrawable(null);
	}
	/*======================================================
	: һͼʾ
	:  
			layerName   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(String layerName) {
		HFLayerWidget layerWidget = findLayerByName(layerName);
		addLayerWidget2Display(layerWidget);
	}
	/*======================================================
	: һͼʾ
	:  
			layerIndex   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(int index) {
		HFLayerWidget layerWidget = getLayerByIndex(index);
		if(layerWidget != null) {
			mScrollView.addView(layerWidget);
		}
	}	
	/*======================================================
	: ʾƳһʾ
	:  
			layerName   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void removeLayerWidgetFromDisplay(String layerName) {
		HFLayerWidget layerWidget = findLayerByName(layerName);
		if(layerWidget != null) {
			mScrollView.removeView(layerWidget);
		}
	}
	public void removeLayerWidgetFromDisplay(HFLayerWidget layerWidget) {
		if(layerWidget != null) {
			mScrollView.removeView(layerWidget);
		}
	}
	public synchronized String getName() {
		if(mModeData != null && mModeData.getModeName() != null)
		   return mModeData.getModeName();
		return "";
	}
	protected void setName(String widgetName) {
		if(mModeData != null)
		   mModeData.setModeName(widgetName);
	}
	/*=======================================================
	: ȡؼId
	: 
	ֵ: ؼId
	======================================================*/	
	public int getModeId() {
		if(mModeData != null)
		  return mModeData.getModeId();
		return -1;
	}
	/*=======================================================
	: ÿؼId
	: id [in] ؼId
	ֵ: 
	======================================================*/
	public void setModeId(int id) {
		if(mModeData != null)
		   mModeData.setModeId(id);
	}	
	/*======================================================
	: ͨGroupIdRadioButton
	:  groupid       [in] RadioButtonGroupId
	ֵ: еλ
	======================================================*/
	protected int findRadioButton(int groupId) {
		
		HFRadioButtonWidget radioButton = null;
		
		for(int index = 0; index < mRadioButtons.size(); index++) {
			radioButton = mRadioButtons.get(index);
			if(radioButton != null && radioButton.getGroupId() == groupId) {
				return index;
			}
		}
		return -1;
	}
	/*======================================================
	: ñѡеRadioButton
	:  in_pRadioButton   [in] ѡеRadioButton
	ֵ: =0:ɹ>0 
	======================================================*/
	public void setRadioButton(HFRadioButtonWidget radioButton) {
		if(radioButton == null) {
			return ;
		}
		int index = findRadioButton(radioButton.getGroupId());
		if(index == -1) {
			mRadioButtons.add(radioButton);
		} 
		else {
			HFRadioButtonWidget priorRadioButton = mRadioButtons.get(index);
			if(priorRadioButton != radioButton) {
				priorRadioButton.setChecked(false);
				mRadioButtons.remove(index);
				mRadioButtons.add(radioButton);
			}
		}
	}
	
	public void SetReEnterFlag(boolean reEnterFlag){
		this.reEnterFlag = reEnterFlag;
	}
	
	@Override
	public void onStart(){
		doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Start_Begin);
		super.onStart();
		if(reEnterFlag == true && HFModesManager.getCurrentMode() == this){
			reEnterFlag = false;
			//onReEnter
			onReEnter();	
			//drawable
			reloadDrawable();
		}
		//еͼؼҪͼUI
		if(mIsContainMapView == true)
			HPGLRenderer.setMapUISynchronized(true);
		
		HPGLRenderer.setMapUpdateEnable(true);
		HFModeWidget modeWidget = HFModesManager.getCurrentMode();
		if(modeWidget != null && (modeWidget instanceof HFModeFragment)){
		   HFModeFragment fragment = (HFModeFragment)modeWidget;
		   if(fragment == this)
		     HPGLRenderer.setMapGLRenderer(true);
		}
		doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Start_Finish);
	}
	//activityonResume
	@Override
	public void onResume() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Begin);
		super.onResume();
		if(mIsMenuMode == false)
		  HPMapAPI.setContainMapView(mIsContainMapView);
		//ﴦЧ
		if(mScrollView != null && mScrollView.getBackground() != null){
			mFragmentHandler.sendEmptyMessageDelayed(HF_CLEAR_BACKGROUND_MESSAGE_ID, mPendingTransitionTime+mPendingTransitionTime/2);
		}
	    //OnUpdateص
		onUpdate();	
		//ͼͬUI
		HPGLRenderer.doMapUISynchronized();
		//һûгɹصģʽ
		HFModesManager.returnLastMode();
		//һδɵĿϢеĻ
		HFModesManager.sendLastTargetMsg();
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Finish);
    	
    	if(checkLayoutOnResume){
    		mContext.checkLayoutOnResume();
    	}else{
    		if(resetLayout){
        		mContext.reloadLayout(null,false);
        		resetLayout();
        	}else {
//        		if(Build.VERSION.SDK_INT >= 24
//        				&& (Build.MANUFACTURER.equalsIgnoreCase("OPPO"))) {
//		    		if(HFModesManager.shouldResetScreenOnFrameCreate) {
//		    			mContext.checkLayoutOnResume();
//		    			HFModesManager.shouldResetScreenOnFrameCreate = false;
//		    		}
//        		}
        	}	
    	}
    	checkLayoutOnResume = false;
    	resetLayout = false;
	}
	@Override
	public void onPause() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Begin);
		super.onPause();
		//رģʽװ
		closeModeLoader(null);
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Finish);
	}
	//activityonRestart
	protected void onRestart() {
		doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Begin);
		//onReEnter
		onReEnter();	
		//drawable
		reloadDrawable();
		doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Finish);
	}
	//activityKeyup
	public boolean onKeyUp (int keyCode, KeyEvent event) {
		
		HPWidgetEventArgument eventArgs = getEventArgs();
		eventArgs.eventType = (HPWidgetEventType.eWidgetEventType_Key);
		eventArgs.eventSubtype = (HPWidgetKeyEvent.eWidgetKeyEvent_Up);
		HPWidgetKeyArgument keyArgs = (HPWidgetKeyArgument) eventArgs.obtainEventArgs(HPWidgetEventType.eWidgetEventType_Key, 
																HPWidgetKeyEvent.eWidgetKeyEvent_Up);
		keyArgs.keyCode = (keyCode);
		keyArgs.keyStatus = (event.getFlags());
		if(onMessageProc(eventArgs))
			return true;
		return false;
	}
	//activityKeydown
	public boolean onKeyDown (int keyCode, KeyEvent event) {
		
		HPWidgetEventArgument eventArgs = getEventArgs();
		eventArgs.eventType = (HPWidgetEventType.eWidgetEventType_Key);
		eventArgs.eventSubtype = (HPWidgetKeyEvent.eWidgetKeyEvent_Down);
		HPWidgetKeyArgument keyArgs = (HPWidgetKeyArgument) eventArgs.obtainEventArgs(HPWidgetEventType.eWidgetEventType_Key, 
																HPWidgetKeyEvent.eWidgetKeyEvent_Down);
		keyArgs.keyCode = (keyCode);
		keyArgs.keyStatus = (event.getFlags());
		if(onMessageProc(eventArgs))
			return true;
		return false;
	}
	//activityKeydown
	public boolean onTouchEvent (MotionEvent event) {
		int actionCode = event.getAction() & MotionEvent.ACTION_MASK;
		HPWidgetEventArgument eventArgs = getEventArgs();
		if(HPWidgetEvent.convertTouchEvent(event, eventArgs)) {
			if(onMessageProc(eventArgs))
				return true;
		}
		if(actionCode == MotionEvent.ACTION_DOWN) {
			HFButtonWidget.mPressButton = null;
	   	}
		return  false;
	}
	
	/*=======================================================
	: ؼʼ
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onBeforeInit() {
		return false;
	}   	
	/*=======================================================
	: ؼʼ
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onInit() {
		return false;
	}   
	/*======================================================
	: ģʽ뺯
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onReEnter() {
		if(resetLayout){
    		mContext.reloadLayout(null,false);
    		resetLayout();
    	}
    	resetLayout = false;
    	
		return false;
	}
	/*======================================================
	: ģʽ¼
	: eventArgs [in] ¼
	ֵ: TRUE: ¼Ѵ FALSE: ¼δ
	======================================================*/
	protected boolean onMessageProc(HPWidgetEventArgument event) {
		if((event.eventType == HPWidgetEventType.eWidgetEventType_Key)
				&&(event.eventSubtype == HPWidgetKeyEvent.eWidgetKeyEvent_Up)) {
			HPWidgetKeyArgument keyEvent = event.getKeyEventArgs(); 
			 if(keyEvent.keyCode == KeyEvent.KEYCODE_BACK) {
				 HFModesManager.returnMode(getPendingTransition());
				 return true;
			 }
		}		
		return false;
	}    
	/*======================================================
	: ģʽĸº
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onUpdate() {
		return false;
	}
	/*======================================================
	: ģʽĹرպ
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onClose() {
		return false;
	}
	public HPWidgetEventArgument getEventArgs() {
		if(mEventArgs == null) {
			mEventArgs = new HPWidgetEventArgument();
		}
		return mEventArgs;
	}
	/*=======================================================
	: ȡؼλ
	: 
	ֵ:  ؼλ
	======================================================*/	
	public void getBound(HFWidgetBound bound) {
		if(bound != null) {
			bound.setLeft(0);
			bound.setTop(0);
			bound.setWidth(mContext.getWindowManager().getDefaultDisplay().getWidth());
			bound.setHeight(mContext.getWindowManager().getDefaultDisplay().getHeight());
		}
		return ;
	}	
	/*======================================================
	: װdrawable
	:  
	ֵ: 
	======================================================*/
	protected void reloadDrawable() {
		int index;
		HFLayerWidget layer = null;
		for(index = 0; index < mLayers.size(); index++) {
			layer = mLayers.get(index);
			if(layer != null) {
				layer.reloadDrawable();
			}
		}
	}
	/*======================================================
	: װͼؼ
	:  
	ֵ: 
	˵ıģʽеͼVisible֮øú
	======================================================*/
	public void inflate() {
		if(!isOptimized())
			return ;
		HFLayerWidget layer = null;
		ArrayList<HFLayerWidget> layers = new ArrayList<HFLayerWidget>();
		for(int index = 0; index < mLayers.size(); ++index) {
			layer = mLayers.get(index);
			if(layer != null && !layer.isReady() && layer.getVisible()) {
				layers.add(layer);
			}
		}	
		if(layers.size() == 0)
			return ;
		
    	HFModeLoader modeLoader = getModeLoader();
        if(modeLoader == null) 
        	return ;

		for(int index = 0; index < layers.size(); ++index) {
			layers.get(index).loadWidgets(mContext, modeLoader);
		}
		closeModeLoader(modeLoader);
		modeLoader = null;
		layers = null;
	}
	/*=======================================================
	:
	    Ϣ
	:
	    in_Handle:Ϣľ
	    ulMsg:Ϣ
	    ulParams1:1
	    ulParams2:2
		
	ֵ:
	    != 0 ɹ---bool
	=======================================================*/
	public int sendMessage(Object in_Handle, int msgId, Object params1, Object params2) {
		return mContext.sendMessage(in_Handle, msgId, params1, params2);
	}
	public int sendMessageDelayed(Object in_Handle, int msgId, Object params1, Object params2,long delayMillis) {
		return mContext.sendMessageDelayed(in_Handle, msgId, params1, params2, delayMillis);
	}
	
	public void sendMessage(int what, Object obj) {
		sendMessage(null, what, obj, null);
	}
	public void sendEmptyMessage(int what) {
		sendMessage(null, what, null, null);
	}
	public HFOnMessageInterface getOnMessageListener() {
		return mOnMessageListener;
	}
	public void setOnMessageListener(HFOnMessageInterface listener) {
		mOnMessageListener = listener;
	}
	public float getXScaleFactor() {
		return mXScaleFactor;
	}
	protected void setXScaleFactor(float mXScaleFactor) {
		this.mXScaleFactor = mXScaleFactor;
	}
	public float getYScaleFactor() {
		return mYScaleFactor;
	}
	protected void setYScaleFactor(float mYScaleFactor) {
		this.mYScaleFactor = mYScaleFactor;
	}
	/*=======================================================
	:
		
	:
		
	ֵ:
	=======================================================*/	
	protected void calcScaleFactor() {
		//X᷽
		mXScaleFactor = 1.0f;
		//Y᷽
		mYScaleFactor = 1.0f; 		
		if(HFModesManager.isScaleMode()) {
			float screenWidth = 0;
			float screenHeight = 0;
			if(HFModesManager.isLandScapeMode() && mOrientation == HFOrientation.eOrientation_Portrait){
				screenWidth = HFModesManager.getScreenHeight();
				screenHeight = HFModesManager.getScreenWidth() - HFModesManager.getStatusBarHeight();
			}else{
				screenWidth = HFModesManager.getScreenWidth();
				screenHeight = HFModesManager.getScreenHeight() - HFModesManager.getStatusBarHeight();
			}
			
			
			float modeWidth = mModeData.getWidth();
			float modeHeight =  mModeData.getHeight() - HFModesManager.getDesignBarHeight();
			if(screenWidth > 0 && screenHeight > 0) {
				mXScaleFactor = screenWidth/modeWidth;
				mYScaleFactor = screenHeight/modeHeight;
			}
		}
		int xFactor = (int)(mXScaleFactor * 100);
		int yFactor = (int)(mYScaleFactor * 100);
		mXScaleFactor = (xFactor == 0) ? 1.0f : mXScaleFactor;
		mYScaleFactor = (yFactor == 0) ? 1.0f : mYScaleFactor;
	}
	/*=======================================================
	:
		õźX
	:
		originX [in] ԭʼ
	ֵ:
		ź
	=======================================================*/	
	protected int getXScaleCoords(int originX) {
		double xx = originX;
		if(HFModesManager.isScaleMode()) {
			xx = xx * getXScaleFactor(); 
		}
		return (int) Math.ceil(xx);
	}
	/*=======================================================
	:
		õź
	:
		originX [in] ԭʼ
	ֵ:
		ź
	=======================================================*/	
	protected int getYScaleCoords(int originY) {
		double yy = originY;
		if(HFModesManager.isScaleMode()) {
			yy = yy * getYScaleFactor(); 
		}
		return (int) Math.ceil(yy);
	}	
	/*=======================================================
	:
		Կؼ
	:
		bound [in] ԭʼ
		deltaXY [in] ƫ
	ֵ:
	˵:
		ʱֻ꣬ſؼĿ
	=======================================================*/	
	public void scaleCoords(HFWidgetBound bound,int fixedshape) {
		if(bound != null && HFModesManager.isScaleMode()) {
			int w = getXScaleCoords(bound.getWidth());
			int h = getYScaleCoords(bound.getHeight());
			int l = getXScaleCoords(bound.getLeft());
			int t = getYScaleCoords(bound.getTop());
			if(fixedshape > 0){
				if(getXScaleFactor() > getYScaleFactor()){
					w = getYScaleCoords(bound.getWidth());
					
					/*
					*        -------------
					*        | 2 | 3 | 4 |
					*        |------------
					*        | 5 | 1 | 6 |
					*        |------------
					*        | 7 | 8 | 9 |
					*        |------------
					*
					*/

					//߶򲻾ʾ 
					if(l > 0){	
						if(fixedshape == 2 || fixedshape == 5 || fixedshape == 7){//
							
						}else if(fixedshape == 3 || fixedshape == 1 || fixedshape == 8){//ж
							l += (int) Math.ceil(bound.getWidth() * (mXScaleFactor - mYScaleFactor)) / 2;
						}else if(fixedshape == 4 || fixedshape == 6 || fixedshape == 9){//Ҷ
							l += (int) Math.ceil(bound.getWidth() * (mXScaleFactor - mYScaleFactor));
						}
					}
					
				}else{
					h = getXScaleCoords(bound.getHeight());
					//߶򲻾ʾ
					if(t > 0){
						if(fixedshape == 2 || fixedshape == 3 || fixedshape == 4){//
							
						}else if(fixedshape == 5 || fixedshape == 1 || fixedshape == 6){//ж
							t += (int) Math.ceil(bound.getHeight() * (mYScaleFactor - mXScaleFactor)) /2;
						}else if(fixedshape == 7 || fixedshape == 8 || fixedshape == 9){//ײ
							t += (int) Math.ceil(bound.getHeight() * (mYScaleFactor - mXScaleFactor));
						}
					}
					
				}
			}
			bound.setLeft(l);
			bound.setTop(t);
			bound.setWidth(w <= 0 ? 1:w);
			bound.setHeight(h <= 0 ? 1:h);
		}
	}
	/*=======================================================
	:
		Layerؼ
	:
		bound 		[in] ԭʼ
		out_DeltaXY	[out] źƫ
	ֵ:
	˵:
		ʱֻ꣬ſؼĿ
	=======================================================*/	
	protected void scaleLayerCoords(HFWidgetBound bound, HFWidgetPoint out_DeltaXY) {
		if(bound != null && HFModesManager.isScaleMode()) {
			int x0 = bound.getLeft();
			int y0 = bound.getTop();
			int x1 = getXScaleCoords(x0);
			int y1 = getYScaleCoords(y0);
			out_DeltaXY.X = x1 - x0;
			out_DeltaXY.Y = y1 - y0;
			bound.setLeft(x1);
			bound.setTop(y1);
		}
	}	
	/**
	* ȡǰģʽĶ
	*
	* @param  
	* @param  
	* @return 
	*/		
	public int getPendingTransition() {
		return mPendingTransition;
	}
	/**
	* õǰģʽĶ
	*
	* @param  defaultTransition [in] 
	* @param  
	* @return 
	*/		
	protected void setPendingTransition(int pendingTransition) {
		mPendingTransition = pendingTransition;
	}
	/**
	* ݵǰģʽconfigorientation
	*
	* @param  cfgOrientation [in] 
	* @param  
	* @return 
	*/			
	protected int parseOrientation(int cfgOrientation) {
		int orientation = HFOrientation.eOrientation_Unknown;
		switch(cfgOrientation) {
		case Configuration.ORIENTATION_LANDSCAPE: 
			orientation = HFOrientation.eOrientation_Landscape;
			break;
		case Configuration.ORIENTATION_PORTRAIT: 
			orientation = HFOrientation.eOrientation_Portrait;
			break;
		case Configuration.ORIENTATION_SQUARE: 
			orientation = HFOrientation.eOrientation_Square;
			break;
		}
		return orientation;
	}
//	/**
//	* ģʽл
//	*
//	* @param  newConfig [in] config
//	* @param  
//	* @return 
//	*/		
//	@Override
//	public void onConfigurationChanged(Configuration newConfig) {
//		super.onConfigurationChanged(newConfig);
//		HFOnChangeOrientationInterface listener = HFModesManager.getOnChangeOrientationListener();
//		if(listener != null) {
//			int orientation = parseOrientation(newConfig.orientation);
//			if(listener.OnChangeOrentation(mContext, orientation)) {
//				changeOrientation(orientation);
//			}
//		}
//	    if( mIsMenuMode == true){
//           HFSlideMenu.mMenuWidth = getMenuWidth();
//        }
//	}
	/**
	* л
	*
	* @param  mOrientation 		[in] Ϣ
	* @param  
	* @return 
	*/		
	protected void changeOrientation(int orientation) {
	
        boolean shouldInit = true;
    	if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Landscape && HFModesManager.isLandScapeMode())
    		shouldInit = true;
    	else if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Portrait && !HFModesManager.isLandScapeMode())
    		shouldInit = true;
    	else 
    		shouldInit = false;
    	if(!shouldInit)
    		return;
       reLayout(orientation);
	}
	
	/** ²
	 * @param orientation
	 * @return void
	 * @author LiangYJ
	 * @date 2015-10-23 12:03:31
	 */ 
	public void reLayout(int orientation){
		HFLayerWidget pLayer = null;
    	HFModeLoader modeLoader = getModeLoader();
        if(	modeLoader == null 
        	|| orientation == getOrientation()) {
        	return ;
        }	
        //лҪ¼ģʽͼ
        loadMode(HFModesManager.getLaoutsPath() + getModeName());
        //ú
        setOrientation(orientation);
        //бͼ
        ArrayList<HFLayerWidget> listLayers = new ArrayList<HFLayerWidget>();
        
        //added by DingHU 20151020
		if (isChangeOrationNeedRenewModeData) {
			mScrollView.removeAllViews();
			mLayers.clear();
			// ¼ģʽ
			loadLayerWidgets();
		}
       
        //end
        
    	//װģʽ
    	modeLoader.getModeData(mModeData);
    	//
    	calcScaleFactor();
    	//ȡͼܸ
    	int numLayers = modeLoader.getNumOfLayers();
    	//ȴбͼ
    	for(int i = 0; i < numLayers; i++) {
        	HFLayerStorage playerData = new HFLayerStorage();
    		if(0 == modeLoader.getLayerData(i, playerData)) {
    			if(playerData.getParent() > 0) {
    				//createLayerWidget½ʱн
    				//scaleCoords(playerData.getBound(),false); 
    				//бͼ㣬ݴ
    				pLayer = createLayerWidgets(modeLoader, playerData); 
    				if(pLayer != null) {
    					listLayers.add(pLayer);
    				}
    			}
    		}
    	}	
    	//ٴбͼ
    	for(int i = 0; i < numLayers; i++) {
        	HFLayerStorage playerData = new HFLayerStorage();
    		if(0 == modeLoader.getLayerData(i, playerData)) {
    			if(playerData.getParent() <= 0) {
    				pLayer = findLayerByName(playerData.getName());
    				if(pLayer != null) {
        				scaleCoords(playerData.getBound(),0);
    					pLayer.changeOrientation(mContext, modeLoader, playerData, listLayers);
    				}
    			}		
    		}
    	}
    	//ݴбͼ
    	listLayers.clear();
    	listLayers = null;
    	//бͼ
    	closeModeLoader(modeLoader);	
	}
	
	/**
	* ȡģʽ־
	*
	* @param  
	* @param  
	* @return ģʽ־
	*/		
	public int getOrientation() {
		return mOrientation;
	}
	/**
	* ģʽ־
	*
	* @param  orientation [in] ģʽ־
	* @param  
	* @return 
	*/		
	protected void setOrientation(int orientation) {
		mOrientation = orientation;
	}
	/**
	* ȡǰĵͼؼ
	*
	* @param  
	* @param  
	* @return ͼؼ
	*/	
	public HFMapWidget getMapWidget() {
		return mContext.getMapWidget();
	}
	/**
	* ȡǰĵͼģʽ
	*
	* @param  
	* @param  
	* @return ͼģʽ
	*/	
	public HFMapActivity getMapMode() {
		//return (HFMapActivity)getActivity();
		return (HFMapActivity)HFModesManager.getMapMode();
	}
	/*======================================================
	: ñѡеRadioButton
	:  in_pRadioButton   [in] ѡеRadioButton
	ֵ: =0:ɹ>0 
	======================================================*/
	public Context getContext() {
		if(HFModesManager.getMapMode() != null)
		   return HFModesManager.getMapMode();
		return getActivity();
	}

	@Override
	public HFModeFragment returnToFragment(String modeName, int pendingTransition) {
		HFMapActivity mapMode = getMapMode();
		if(mapMode != null && HFModesManager.isSaveInstanceState() == false) {
			return mapMode.returnToFragment(modeName, pendingTransition);
		}
		return null;
	}
	@Override
	public HFModeFragment returnToFragment(String modeName, int pendingTransition,boolean isTag) {
		HFMapActivity mapMode = getMapMode();
		if(mapMode != null && HFModesManager.isSaveInstanceState() == false) {
			return mapMode.returnToFragment(modeName, pendingTransition,isTag);
		}
		return null;
	}
	@Override
	public HFModeWidget returnFragment(HFModeWidget mode, int pendingTransition) {
		HFMapActivity mapMode = getMapMode();
		if(mapMode != null && HFModesManager.isSaveInstanceState() == false) {
			return mapMode.returnFragment(mode, pendingTransition);
		}
		return null;
	}
	@Override
	public HFModeWidget returnFragment(HFModeWidget mode, int pendingTransition,boolean isTag) {
		HFMapActivity mapMode = getMapMode();
		if(mapMode != null && HFModesManager.isSaveInstanceState() == false) {
			return mapMode.returnFragment(mode, pendingTransition,isTag);
		}
		return null;
	}
	@Override
	public Application getApplication() {
		HFMapActivity mapMode = getMapMode();
		if(mapMode != null) {
			return mapMode.getApplication();
		}
		return null;
	}
	@Override
	public void finish() {
		returnFragment(this, getPendingTransition());
	}	
	/*======================================================
	: ȡǰģʽ
	:    
	ֵ:  ǰģʽ
	======================================================*/
	public HFModeWidget getCurrentMode() {
		return this;
	}	
	/*======================================================
	: ȡ˵
	:    
	ֵ:  ˵
	======================================================*/
	public HFSlideMenu getSlideMenu() {
		HFModeActivity mMode = (HFModeActivity) getContext();
		return mMode.getSlideMenu();
	}
	
	/*======================================================
	: жϵǰģʽǷmapViewؼ
	:    
	ֵ: truefalse:
	======================================================*/
	public boolean isModeContainMapView(){
		return mIsContainMapView;
	}
	/*======================================================
	: ȡȫֻ
	:    
	ֵ:  ȫֻ
	======================================================*/
	public HPSysEnv getSysEnv() {
		return HPAppEnv.getSysEnv();
	}
	
	/*=======================================================
	: ͼ
	: λͼ
	ֵ:  
	======================================================*/	
	public Bitmap getScreenShot(Rect rect){
		 // ViewҪͼView
		mScrollView.clearFocus();
		mScrollView.setPressed(false);
///		mScrollView.setDrawingCacheEnabled(true);
	/*	boolean willNotCache = mScrollView.willNotCacheDrawing();
		mScrollView.setWillNotCacheDrawing(false);
		int color = mScrollView.getDrawingCacheBackgroundColor();
		mScrollView.setDrawingCacheBackgroundColor(0);
		if (color != 0) {
			mScrollView.destroyDrawingCache();
		}
		mScrollView.buildDrawingCache();
        Bitmap cache = mScrollView.getDrawingCache();
        Bitmap bitmap = null;
        if(cache != null){
	        if(rect == null){
	           bitmap = Bitmap.createBitmap(cache, 0, 0, cache.getWidth(), cache.getHeight());
	        }else{
	           bitmap = Bitmap.createBitmap(cache, rect.left, rect.top, rect.width(), rect.height());
	        }
        }
        mScrollView.destroyDrawingCache();
 ///   	mScrollView.setDrawingCacheEnabled(false);
        mScrollView.setWillNotCacheDrawing(willNotCache);
        mScrollView.setDrawingCacheBackgroundColor(color);*/
		
	    Bitmap screenshot = null;  
	    int width = mScrollView.getWidth();
	    int height = mScrollView.getHeight();
	    if(width <= 0){
	    	width = HFModesManager.getScreenWidth();
	    }
	    if(height <= 0){
	    	height = HFModesManager.getScreenHeight();
	    }
	    if(width > 0 && height > 0){
	    	try{
				screenshot = Bitmap.createBitmap(width, height, Config.ARGB_8888);  
			    Canvas c = new Canvas(screenshot);  
			    mScrollView.draw(c);  
			    if(screenshot != null && rect != null)
			    {
			    	Bitmap temp = Bitmap.createBitmap(screenshot, rect.left, rect.top, rect.width(), rect.height());
			    	screenshot.recycle();
			    	screenshot = null;
			    	return temp;
			    }
	    	}catch(Exception e){
	    		return null;
	    	}
	    }
	    return screenshot; 
		
	}
	
	/*======================================================
	: 
	:  
	
	ֵ: 
	======================================================*/
	public View getRootView(){
		return mScrollView;
	}
	
	/*======================================================
	: ȡͼActivity״̬
	ֵ: 
	======================================================*/
	public int getModeActivityState(){
		return mContext.getModeActivityState();
	}
	
	/*======================================================
	: 
	:Ļ  
	
	ֵ: 
	======================================================*/
	public void setScreenOrientation(int requestedOrientation){
		int Orientation = ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED;
		if(requestedOrientation == HFOrientation.eOrientation_Portrait)
			Orientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT;
		else if(requestedOrientation == HFOrientation.eOrientation_Landscape)
			Orientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE;
		mContext.setRequestedOrientation(Orientation);
	}
	
	/*======================================================
	: ȡFragmentAttachState״̬
	ֵ: 
	======================================================*/
	//public boolean getAttachState(){
	//	return bAttachState;
	//}
	
	private class HFFragmentHandler extends Handler {
		@Override
		public void handleMessage(Message msg) {
		   switch(msg.what){
		   case HF_CLEAR_BACKGROUND_MESSAGE_ID:
			   HFModeWidget modeWidget = HFModesManager.getCurrentMode();
			   if(modeWidget != null && modeWidget.equals(HFModeFragment.this))
				   cleanModeBackground();
			   break;
		   }
		}
	}
	
    private void initRequestArgs() {
    	Bundle args = getArguments();
    	if(args != null && args.containsKey(KEY_REQUEST_CODE)) {
    		mResult = new HFFragmentResult();
    		mResult.setRequestCode(args.getInt(KEY_REQUEST_CODE));
    	}
    	//ӳʼлȡǷŻͼ㼰ؼ־
    	if(args != null && args.containsKey(HFModesManager.KEY_OPTIMIZED_CODE)) {
    		setIsOptimized(args.getBoolean(HFModesManager.KEY_OPTIMIZED_CODE));
    	}    	
    }
    private boolean isRequestResult() {
    	return (mResult != null && mResult.isRequestResult());
    }
	public final void setResult (int resultCode, Intent data) {
		if(isRequestResult()) {
			mResult.setResultCode(resultCode);
			mResult.setResultData(data);
		}
	}
	protected HFFragmentResult getResult() {
		return mResult;
	}
	public Intent getIntent() {
		if(mIntent == null)
			mIntent = new Intent();
		return mIntent;
	}
	protected void setIntent(Intent intent) {
		this.mIntent = intent;
	}
	public boolean isOptimized() {
		return mIsOptimized;
	}

	public void setIsOptimized(boolean mIsOptimized) {
		this.mIsOptimized = mIsOptimized;
	}
	/** ǷͨaddFragmentfragment
	 * @return boolean
	 * @author LiangYJ
	 * @date 20171031 3:16:36
	 */ 
	public boolean isStartedByAdd() {
		return mIsStartedByAdd;
	}

	public void setIsStartedByAdd(boolean mIsStartedByAdd) {
		this.mIsStartedByAdd = mIsStartedByAdd;
	}
	public int getPendingTransitionTime() {
		return mPendingTransitionTime;
	}

	public void setPendingTransitionTime(int mPendingTransitionTime) {
		this.mPendingTransitionTime = mPendingTransitionTime;
	}

	protected class HFFragmentResult {
		
		private int requestCode;
		private int resultCode;
		private Intent resultData;
		public HFFragmentResult() {
			requestCode = 0;
			resultCode = 0;
			resultData = null;
		}
		public int getRequestCode() {
			return requestCode;
		}
		public void setRequestCode(int code) {
			this.requestCode = code;
		}		
		public int getResultCode() {
			return resultCode;
		}
		public void setResultCode(int code) {
			this.resultCode = code;
		}
		public Intent getResultData() {
			return resultData;
		}
		public void setResultData(Intent data) {
			this.resultData = data;
		}
		public boolean isRequestResult() {
			return (requestCode != 0);
		}
	}
	public boolean isExistFragment(String modeName){
		return false;
	}
	
	private void doAnalytics(int type){
		if(HFModesManager.getAnalyticsListener() == null)
			return;
		if(mAnalyticsStorage == null){
			mAnalyticsStorage = new HFAnalyticsStorage();
			mAnalyticsStorage.setCurrentTime(System.currentTimeMillis());
		}
		mAnalyticsStorage.setLifeCycle(type);
		mAnalyticsStorage.setModeName(getName());
		if(type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Begin ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Start_Begin ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Begin ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Begin || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Begin || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Begin || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Stop_Begin){
			mAnalyticsStorage.setCostTime(0);
		}else if(type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Finish ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Start_Finish ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Finish ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Finish || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Finish || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Finish || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Stop_Finish){
			mAnalyticsStorage.setCostTime(System.currentTimeMillis() - mAnalyticsStorage.getCurrentTime());
		}
		mAnalyticsStorage.setCurrentTime(System.currentTimeMillis());
		HFModesManager.getAnalyticsListener().onGetAnalyticsMsg(mAnalyticsStorage);
	}

	/** @return the mSingleTag*/
	public String getSingleTag() {
		return mSingleTag;
	}

	/** @param mSingleTag the mSingleTag to set*/
	public void setSingleTag(String mSingleTag) {
		this.mSingleTag = mSingleTag;
	}
	
	public interface IKeyBoardListener{
		public void onKeyBoardDisplay(boolean isShow);
	}
	
//	/** ü̼¼
//	 * @param listener
//	 * @return void
//	 * @author LiangYJ
//	 * @date 2015-8-31 6:43:55
//	 */ 
//	public void setOnKeyBoardListener(final IKeyBoardListener listener){
//		mKeyBoardListener = listener;
//	}
//	
//	/** Ƿ״̬
//	 * @return
//	 * @return boolean
//	 * @author LiangYJ
//	 * @date 2015-8-31 7:12:07
//	 */ 
//	public boolean isKeyBoardDisplay(){
//		return mIsKeyBoardDisplay;
//	}
	 public byte isVeiledEffect() {
			if(mModeData != null)
				return mModeData.getB2VeiledEffect();
			return 0;
	 }
	 
	 /** onResumeʱ¼һ²
	 * @param resetLayout
	 * @author LiangYJ
	 * @date 20171024 5:23:17
	 */ 
	public void setResetLayoutOnResume(boolean resetLayout){
		 this.resetLayout = resetLayout;
	 }
	
	protected void resetLayout(){
		
	}
	
	protected void beforeResetLayout(){
		
	}
}
